diff -pru org.zirco_18_src-orig/res/layout/preferences_activity.xml org.zirco_18_src/res/layout/preferences_activity.xml
--- org.zirco_18_src-orig/res/layout/preferences_activity.xml	2012-05-16 23:37:25.000000000 +0200
+++ org.zirco_18_src/res/layout/preferences_activity.xml	2017-12-08 16:53:56.792085365 +0100
@@ -148,6 +148,21 @@
 			android:summary="@string/PreferencesActivity.UserAgentPreferenceSummary"
 			android:key="BrowserUserAgent" />	
 		<CheckBoxPreference
+			android:title="@string/PreferencesActivity.DisableCORSPreferenceTitle"
+			android:defaultValue="false"
+			android:summary="@string/PreferencesActivity.DisableCORSPreferenceSummary"
+			android:key="BrowserDisableCORS" />
+		<CheckBoxPreference
+			android:title="@string/PreferencesActivity.EnableCORSSameDomainPreferenceTitle"
+			android:defaultValue="true"
+			android:summary="@string/PreferencesActivity.EnableCORSSameDomainPreferenceSummary"
+			android:key="BrowserEnableCORSSameDomain" />
+		<CheckBoxPreference
+			android:title="@string/PreferencesActivity.DisableCORSRedirectionPreferenceTitle"
+			android:defaultValue="false"
+			android:summary="@string/PreferencesActivity.DisableCORSRedirectionPreferenceSummary"
+			android:key="BrowserDisableCORSRedirection" />
+		<CheckBoxPreference
 			android:title="@string/PreferencesActivity.EnableJavascriptPreferenceTitle"
 			android:defaultValue="true"
 			android:summary="@string/PreferencesActivity.EnableJavascriptPreferenceSummary"
@@ -285,4 +300,4 @@
 			android:summary="@string/PreferencesActivity.ChangelogPreferenceSummary"
 			android:key="Changelog" />
 	</PreferenceCategory>
-</PreferenceScreen>
\ Manca newline alla fine del file
+</PreferenceScreen>
Solo in org.zirco_18_src/res/layout: preferences_activity.xml.orig
diff -pru org.zirco_18_src-orig/res/values/strings.xml org.zirco_18_src/res/values/strings.xml
--- org.zirco_18_src-orig/res/values/strings.xml	2012-05-16 23:37:34.000000000 +0200
+++ org.zirco_18_src/res/values/strings.xml	2017-12-08 16:53:56.793085365 +0100
@@ -82,6 +82,12 @@
     <string name="PreferencesActivity.BrowserSettingsCategoryTitle">Browser settings</string>
     <string name="PreferencesActivity.HistorySizePreferenceTitle">History size</string>
     <string name="PreferencesActivity.HistorySizePreferenceSummary">History size in days.</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceTitle">Disable CORS</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceSummary">Enable or disable CORS.</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceTitle">Enable CORS within the same domain</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceSummary">Enable or disable CORS within the same domain.</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceTitle">Disable CORS Redirection</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceSummary">Enable or disable CORS Redirection.</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceTitle">Enable JavaScript</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceSummary">Enable or disable JavaScript.</string>
     <string name="PreferencesActivity.LoadImagesPreferenceTitle">Load images</string>
Solo in org.zirco_18_src/res/values: strings.xml.orig
diff -pru org.zirco_18_src-orig/res/values-de/strings.xml org.zirco_18_src/res/values-de/strings.xml
--- org.zirco_18_src-orig/res/values-de/strings.xml	2012-05-16 23:37:34.000000000 +0200
+++ org.zirco_18_src/res/values-de/strings.xml	2017-12-08 16:54:47.143085159 +0100
@@ -82,6 +82,12 @@
     <string name="PreferencesActivity.BrowserSettingsCategoryTitle">Browser Einstellungen</string>
     <string name="PreferencesActivity.HistorySizePreferenceTitle">Verlaufsgröße</string>
     <string name="PreferencesActivity.HistorySizePreferenceSummary">Verlaufsgröße in Tagen.</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceTitle">Disable CORS</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceSummary">Enable or disable CORS.</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceTitle">Enable CORS within the same domain</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceSummary">Enable or disable CORS within the same domain.</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceTitle">Disable CORS Redirection</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceSummary">Enable or disable CORS Redirection.</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceTitle">JavaScript aktivieren</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceSummary">JavaScript ein-/ausschalten.</string>
     <string name="PreferencesActivity.LoadImagesPreferenceTitle">Bilder laden</string>
diff -pru org.zirco_18_src-orig/res/values-es/strings.xml org.zirco_18_src/res/values-es/strings.xml
--- org.zirco_18_src-orig/res/values-es/strings.xml	2012-05-16 23:37:34.000000000 +0200
+++ org.zirco_18_src/res/values-es/strings.xml	2017-12-08 16:53:56.795085365 +0100
@@ -82,6 +82,12 @@
     <string name="PreferencesActivity.BrowserSettingsCategoryTitle">Ajustes del navegador</string>
     <string name="PreferencesActivity.HistorySizePreferenceTitle">Tamaño del historial</string>
     <string name="PreferencesActivity.HistorySizePreferenceSummary">Tamaño del historial en días.</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceTitle">Disable CORS</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceSummary">Enable or disable CORS.</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceTitle">Enable CORS within the same domain</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceSummary">Enable or disable CORS within the same domain.</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceTitle">Disable CORS Redirection</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceSummary">Enable or disable CORS Redirection.</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceTitle">Activar JavaScript</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceSummary">Activar o desactivar JavaScript.</string>
     <string name="PreferencesActivity.LoadImagesPreferenceTitle">Cargar imágenes</string>
Solo in org.zirco_18_src/res/values-es: strings.xml.orig
diff -pru org.zirco_18_src-orig/res/values-fr/strings.xml org.zirco_18_src/res/values-fr/strings.xml
--- org.zirco_18_src-orig/res/values-fr/strings.xml	2012-05-16 23:37:34.000000000 +0200
+++ org.zirco_18_src/res/values-fr/strings.xml	2017-12-08 16:53:56.796085365 +0100
@@ -82,6 +82,12 @@
     <string name="PreferencesActivity.BrowserSettingsCategoryTitle">Paramètres du navigateur</string>
     <string name="PreferencesActivity.HistorySizePreferenceTitle">Historique</string>
     <string name="PreferencesActivity.HistorySizePreferenceSummary">Taille de l\'historique en jours.</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceTitle">Disable CORS</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceSummary">Enable or disable CORS.</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceTitle">Enable CORS within the same domain</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceSummary">Enable or disable CORS within the same domain.</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceTitle">Disable CORS Redirection</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceSummary">Enable or disable CORS Redirection.</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceTitle">Activer le JavaScript</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceSummary">Active ou désactive le JavaScript.</string>
     <string name="PreferencesActivity.LoadImagesPreferenceTitle">Charger les images</string>
Solo in org.zirco_18_src/res/values-fr: strings.xml.orig
diff -pru org.zirco_18_src-orig/res/values-pt-rBR/strings.xml org.zirco_18_src/res/values-pt-rBR/strings.xml
--- org.zirco_18_src-orig/res/values-pt-rBR/strings.xml	2012-05-16 23:37:34.000000000 +0200
+++ org.zirco_18_src/res/values-pt-rBR/strings.xml	2017-12-08 16:53:56.801085365 +0100
@@ -82,6 +82,12 @@
     <string name="PreferencesActivity.BrowserSettingsCategoryTitle">Configurações do navegador</string>
     <string name="PreferencesActivity.HistorySizePreferenceTitle">Tamanho do histórico</string>
     <string name="PreferencesActivity.HistorySizePreferenceSummary">Tamanho do histórico em dias.</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceTitle">Disable CORS</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceSummary">Enable or disable CORS.</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceTitle">Enable CORS within the same domain</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceSummary">Enable or disable CORS within the same domain.</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceTitle">Disable CORS Redirection</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceSummary">Enable or disable CORS Redirection.</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceTitle">Habilitar JavaScript</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceSummary">Habilitar ou desabilitar JavaScript.</string>
     <string name="PreferencesActivity.LoadImagesPreferenceTitle">Carregar imagens</string>
@@ -534,4 +540,4 @@
     <!-- 0.4.3 -->
     <string name="VideoLoading">Carregando vídeo\u2026</string>
     
-</resources>
\ Manca newline alla fine del file
+</resources>
Solo in org.zirco_18_src/res/values-pt-rBR: strings.xml.orig
diff -pru org.zirco_18_src-orig/res/values-zh/strings.xml org.zirco_18_src/res/values-zh/strings.xml
--- org.zirco_18_src-orig/res/values-zh/strings.xml	2012-05-16 23:37:34.000000000 +0200
+++ org.zirco_18_src/res/values-zh/strings.xml	2017-12-08 16:53:56.802085365 +0100
@@ -82,6 +82,12 @@
     <string name="PreferencesActivity.BrowserSettingsCategoryTitle">浏览器设定</string>
     <string name="PreferencesActivity.HistorySizePreferenceTitle">历史记录大小</string>
     <string name="PreferencesActivity.HistorySizePreferenceSummary">每天历史记录大小</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceTitle">Disable CORS</string>
+    <string name="PreferencesActivity.DisableCORSPreferenceSummary">Enable or disable CORS.</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceTitle">Enable CORS within the same domain</string>
+    <string name="PreferencesActivity.EnableCORSSameDomainPreferenceSummary">Enable or disable CORS within the same domain.</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceTitle">Disable CORS Redirection</string>
+    <string name="PreferencesActivity.DisableCORSRedirectionPreferenceSummary">Enable or disable CORS Redirection.</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceTitle">是否支持JavaScript</string>
     <string name="PreferencesActivity.EnableJavascriptPreferenceSummary">如果不支持JavaScript，很多网站效果不能打开，建议打开.</string>
     <string name="PreferencesActivity.LoadImagesPreferenceTitle">是否加载图像</string>
Solo in org.zirco_18_src/res/values-zh: strings.xml.orig
diff -pru org.zirco_18_src-orig/src/org/zirco/ui/components/CustomWebView.java org.zirco_18_src/src/org/zirco/ui/components/CustomWebView.java
--- org.zirco_18_src-orig/src/org/zirco/ui/components/CustomWebView.java	2012-05-16 23:37:26.000000000 +0200
+++ org.zirco_18_src/src/org/zirco/ui/components/CustomWebView.java	2017-12-08 16:53:56.803085365 +0100
@@ -89,6 +89,9 @@ public class CustomWebView extends WebVi
 		WebSettings settings = getSettings();
 		
 		// User settings		
+		settings.setDisableCORS(Controller.getInstance().getPreferences().getBoolean(Constants.PREFERENCES_BROWSER_DISABLE_CORS, false));
+		settings.setEnableCORSSameDomain(Controller.getInstance().getPreferences().getBoolean(Constants.PREFERENCES_BROWSER_ENABLE_CORS_SAME_DOMAIN, true));
+		settings.setDisableCORSRedirection(Controller.getInstance().getPreferences().getBoolean(Constants.PREFERENCES_BROWSER_DISABLE_CORS_REDIRECTION, false));
 		settings.setJavaScriptEnabled(Controller.getInstance().getPreferences().getBoolean(Constants.PREFERENCES_BROWSER_ENABLE_JAVASCRIPT, true));
 		settings.setLoadsImagesAutomatically(Controller.getInstance().getPreferences().getBoolean(Constants.PREFERENCES_BROWSER_ENABLE_IMAGES, true));
 		settings.setUseWideViewPort(Controller.getInstance().getPreferences().getBoolean(Constants.PREFERENCES_BROWSER_USE_WIDE_VIEWPORT, true));
Solo in org.zirco_18_src/src/org/zirco/ui/components: CustomWebView.java.orig
diff -pru org.zirco_18_src-orig/src/org/zirco/utils/Constants.java org.zirco_18_src/src/org/zirco/utils/Constants.java
--- org.zirco_18_src-orig/src/org/zirco/utils/Constants.java	2012-05-16 23:37:26.000000000 +0200
+++ org.zirco_18_src/src/org/zirco/utils/Constants.java	2017-12-08 16:53:56.803085365 +0100
@@ -74,6 +74,9 @@ public class Constants {
 	public static final String PREFERENCES_DEFAULT_ZOOM_LEVEL = "DefaultZoomLevel";
 	
 	public static final String PREFERENCES_BROWSER_HISTORY_SIZE = "BrowserHistorySize";
+	public static final String PREFERENCES_BROWSER_DISABLE_CORS = "BrowserDisableCORS";
+	public static final String PREFERENCES_BROWSER_ENABLE_CORS_SAME_DOMAIN = "BrowserEnableCORSSameDomain";
+	public static final String PREFERENCES_BROWSER_DISABLE_CORS_REDIRECTION = "BrowserDisableCORSRedirection";
 	public static final String PREFERENCES_BROWSER_ENABLE_JAVASCRIPT = "BrowserEnableJavascript";
 	public static final String PREFERENCES_BROWSER_ENABLE_IMAGES = "BrowserEnableImages";
 	public static final String PREFERENCES_BROWSER_USE_WIDE_VIEWPORT = "BrowserUseWideViewPort";
Solo in org.zirco_18_src/src/org/zirco/utils: Constants.java.orig